import math

best_rate = dict()


def get_rate(name):
    if name not in best_rate:
        best_rate[name] = 0.0
    return best_rate[name]


def solve():
    words = input()
    N = int(words.split()[0])
    best_rate["pink"] = 1.0
    for i in range(N):
        O, W, R = input().split()
        R = float(R)
        new_rate = max(get_rate(O), get_rate(W) * R)
        best_rate[O] = new_rate

    ans = get_rate("blue")
    if ans < 0.00000001:
        print("0.000000")
    elif ans > 10.0:
        print("10.000000")
    else:
        print("{:.8f}".format(ans))


if __name__ == "__main__":
    solve()
